/***************************************************************************
 *   Copyright (C) 2006 by Jean-Louis Fuchs                                  *
 *   ganwell@fangorn.ch                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef ANCESTORS_H
#define ANCESTORS_H

#include "AutomateCommand.h"

#include <QAbstractItemModel>

class Ancestors : public QAbstractItemModel, public AutomateCommand
{
    Q_OBJECT
public:
    Ancestors(QObject *, const MonotoneHandlePtr &);
    virtual ~Ancestors();

    // needed Qt Model methods
    QVariant data(const QModelIndex &, int) const;
    Qt::ItemFlags flags(const QModelIndex &) const;
    QVariant headerData(int, Qt::Orientation, int) const;
    QModelIndex index(int, int, const QModelIndex &) const;
    QModelIndex parent(const QModelIndex &) const;
    int rowCount(const QModelIndex &) const;
    int columnCount(const QModelIndex &) const;

public slots:
    void readAncestors(const QStringList &);

signals:
    void ancestorsRead();
    void invalidAncestor(QString);

private:
    void processTaskResult(const MonotoneTaskPtr &);
    QStringList * selRevisions;
    bool sorted;
    MonotoneHandlePtr monotoneHandle;
};

#endif
