/***************************************************************************
 *	 Copyright (C) 2006 by Thomas Keller								   *
 *	 me@thomaskeller.biz												   *
 *																		   *
 *	 This program is free software; you can redistribute it and/or modify  *
 *	 it under the terms of the GNU General Public License as published by  *
 *	 the Free Software Foundation, either version 3 of the License, or	   *
 *	 (at your option) any later version.								   *
 *																		   *
 *	 This program is distributed in the hope that it will be useful,	   *
 *	 but WITHOUT ANY WARRANTY; without even the implied warranty of		   *
 *	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		   *
 *	 GNU General Public License for more details.						   *
 *																		   *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef BRANCHES_H
#define BRANCHES_H

#include "AutomateCommand.h"
#include "TreeBuilder.h"

#include <QStandardItemModel>
#include <QSet>
#include <QBrush>

class Branches : public QStandardItemModel, public AutomateCommand
{
    Q_OBJECT
public:
    Branches(QObject *, const MonotoneHandlePtr &);
    ~Branches();

    void markBranchSuspended(const QString &);

    Qt::ItemFlags flags(const QModelIndex & index) const;

public slots:
    void readBranches();
    void displayBranchesAsTree(bool);

signals:
    void branchesRead(void);

private:
    void processTaskResult(const MonotoneTaskPtr &);
    void rebuildBranchModel();
    bool markSuspendedBranches(QStandardItem *);

    bool branchesAsTree, suspendedBranches;
    QStringList branches;
    QMap<QString, QSet<QString> > activeHeadsMap;
    QMap<QString, QStandardItem *> branchItemMap;

    TreeBuilder * builder;
    MonotoneHandlePtr monotoneHandle;
    QBrush suspendedBranchesBrush;
};

#endif
