/***************************************************************************
 *   Copyright (C) 2008 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef GET_DATABASE_VARIABLES_H
#define GET_DATABASE_VARIABLES_H

#include "AutomateCommand.h"

#include <QAbstractItemModel>

class GetDatabaseVariables : public QAbstractItemModel, public AutomateCommand
{
    Q_OBJECT
public:
    GetDatabaseVariables(QObject *);
    virtual ~GetDatabaseVariables();

    // needed Qt Model methods
    QVariant data(const QModelIndex &, int) const;
    Qt::ItemFlags flags(const QModelIndex &) const;
    QVariant headerData(int, Qt::Orientation, int) const;
    QModelIndex index(int, int, const QModelIndex &) const;
    QModelIndex parent(const QModelIndex &) const;
    int rowCount(const QModelIndex &) const;
    int columnCount(const QModelIndex &) const;

    bool setVariable(const QString &, const QString &, const QString &);
    bool dropVariable(const QString &, const QString &);

public slots:
    void setMonotoneHandle(const MonotoneHandlePtr &);
    void readVariables();

signals:
    void variablesRead();

private:
    void processTaskResult(const MonotoneTaskPtr &);
    MonotoneHandlePtr monotoneHandle;
    // technically we could rewrite the QList<QPair<...>> as QMap<...>,
    // but this structure would be harder to serve the model methods
    QMap<QString, QList<QPair<QString, QString> > > variables;
};

#endif

