/***************************************************************************
 *   Copyright (C) 2006 by Jean-Louis Fuchs                                *
 *   ganwell@fangorn.ch                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef TOPOSORT_H
#define TOPOSORT_H

#include "AutomateCommand.h"

#include <QMap>
#include <QSortFilterProxyModel>

typedef QMap<QString,int> RevisionMap;

class Toposort : public QSortFilterProxyModel, public AutomateCommand
{
    Q_OBJECT
public:
    Toposort(QObject *, const MonotoneHandlePtr &);
    virtual ~Toposort();
    void setSourceModel(QAbstractItemModel *);
    void sort(int, Qt::SortOrder);

signals:
    void sortingFinished();

private:
    void processTaskResult(const MonotoneTaskPtr &);
    bool lessThan(const QModelIndex &, const QModelIndex &) const;
    bool filterAcceptsRow(int, const QModelIndex &) const;

    RevisionMap * ordRevisions;
    MonotoneHandlePtr monotoneHandle;
    bool showRows;
    int sortColumn;
    Qt::SortOrder sortOrder;

private slots:
    void sortModel();
};

#endif

