/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef FILE_EXPORTER_H
#define FILE_EXPORTER_H

#include <QDir>

#include "vocab.h"

class FileExporter : public QObject
{
    Q_OBJECT
public:
    FileExporter(const MonotoneHandlePtr &, const QString &, const QDir &);
    ~FileExporter();
    virtual bool run(const FileEntryList &);

protected:
    bool exportFile(const FileEntry &);

    MonotoneHandlePtr monotoneHandle;
    QDir rootDir;
    QString revision;
};

#endif
