/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef WORKSPACE_COMMITTER_H
#define WORKSPACE_COMMITTER_H

#include "vocab.h"
#include "GetRevision.h"

#include <QDir>
#include <QMap>

//
// TODO: we should make this class working asynchronously and work
// nicely together with QProgressDialog (i.e. subclass it from QThread)
//
class WorkspaceCommitter : public QObject
{
    Q_OBJECT
public:
    WorkspaceCommitter(const MonotoneHandlePtr &, const GetRevision *);
    ~WorkspaceCommitter();

    bool run(const QString &, const QString &, const QString &, const QString &);
    inline QString getRevisionId() const { return revisionId; }

private:
    bool putFile(const QString &, const QString &, const QString &);
    bool putCert(const QString &, const QString &, const QString &, const QString &);
    bool writeRevision(const QString &);
    bool writeOptions(const QMap<QString, QString> &);

    QString revisionId;
    MonotoneHandlePtr monotoneHandle;
    const GetRevision * revModel;
};

#endif
