/***************************************************************************
 *   Copyright (C) 2006 by Ingo Maindorfer								   *
 *   ingo@liquidcooling.de												   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef ICONPROVIDER_H
#define ICONPROVIDER_H

#include <QIcon>
#include <QMap>

class ModelItem;

class IconProvider
{
public:
    static IconProvider * singleton();

    ~IconProvider();

    QIcon getIcon(const ModelItem * item) const;
    QIcon getPlainFileIcon() const;
    QIcon getFileIcon(const QString &) const;
    QIcon getPlainFolderIcon() const;
    QIcon getFolderIcon(const QString &) const;

private:
    IconProvider();
    static IconProvider * instance;

    QMap<QString, QIcon> fileIcons;
    QMap<QString, QIcon> folderIcons;
};

#endif

