/***************************************************************************
 *   Copyright (C) 2006 by Jean-Louis Fuchs                                 *
 *   ganwell@fangorn.ch                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef TREEBUILDER_H
#define TREEBUILDER_H

#include <QStandardItem>

class TreeBuilder : public QObject
{
    Q_OBJECT

public:
    TreeBuilder(QMap<QString, QStandardItem *> &, QStandardItem *, QObject * parent = 0);
    ~TreeBuilder();

    QStandardItem * add(const QString &);
    QStandardItem * add(const QString &, QStandardItem *);
    void addList(const QStringList &);

private:
    void addData(QStandardItem *);
    int overlap(const QString &, const QString &);

    QMap<QString, QStandardItem *> & treeMap;
    QStandardItem * root;
    QChar sep;
};

#endif

