/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#include "AddEditAttribute.h"

AddEditAttribute::AddEditAttribute(
    QWidget * parent, const QString & key, const QString & value
) : Dialog(parent)
{
    setupUi(this);
    Dialog::init();

    // these are added here and not in designer to prevent their
    // automatic localization through uic
    attrKey->insertItem(0, "mtn:execute");
    attrKey->insertItem(1, "mtn:manual_merge");

    int keyPos = attrKey->findText(key);
    if (keyPos == -1)
    {
        attrKey->insertItem(0, key);
        keyPos = 0;
    }

    attrKey->setCurrentIndex(keyPos);
    attrValue->setText(value);
}

AddEditAttribute::~AddEditAttribute() {}

