/***************************************************************************
 *   Copyright (C) 2008 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#include "AddEditDatabaseVariable.h"

AddEditDatabaseVariable::AddEditDatabaseVariable(
    QWidget * parent, const QString & domain,
    const QString & key, const QString & value)
    : Dialog(parent)
{
    setupUi(this);
    Dialog::init();

    connect(
        varDomain, SIGNAL(currentIndexChanged(const QString &)),
        this, SLOT(updatePossibleKeys(const QString &))
    );

    QStringList domains;
    domains << "database" << "known-servers";
    varDomain->addItems(domains);

    int domPos = varDomain->findText(domain);
    if (domPos == -1)
    {
        varDomain->insertItem(0, domain);
        domPos = 0;
    }
    varDomain->setCurrentIndex(domPos);

    int keyPos = varKey->findText(key);
    if (keyPos == -1)
    {
        varKey->insertItem(0, key);
        keyPos = 0;
    }
    varKey->setCurrentIndex(keyPos);

    varValue->setText(value);
}

AddEditDatabaseVariable::~AddEditDatabaseVariable() {}

void AddEditDatabaseVariable::updatePossibleKeys(const QString & domain)
{
    varKey->clear();

    QStringList keys;

    if (domain == "database")
    {
        keys << "default-exclude-pattern"
             << "default-include-pattern"
             << "default-server";
    }

    varKey->addItems(keys);
}

