/***************************************************************************
 *   Copyright (C) 2010 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef ANNOTATE_FILE_H
#define ANNOTATE_FILE_H

#include "Dialog.h"
#include "Annotate.h"
#include "Certs.h"
#include "ui_annotate.h"

class AnnotateFile : public Dialog, private Ui::AnnotateFile
{
    Q_OBJECT

public:
    AnnotateFile(QWidget *, const MonotoneHandlePtr &);
    ~AnnotateFile();

public slots:
    void read(const QString &, const QString &);
    void setSelectedRevision(const QString &);

signals:
    void selectRevision();
    void revisionManifest(const QString &);
    void fileDiff(const QString &, const QString &, const QString &);
    void revisionDiff(const QString &, const QString &, const QString &);

private:
    MonotoneHandlePtr monotoneHandle;
    Annotate * annotateModel;
    QString filePath;

private slots:
    void rowsSelected(const QModelIndexList &);
    void contextMenuRequested(const QModelIndexList &, const QPoint &);
    void doubleClicked(const QModelIndex &);
};

#endif
