/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef APPLICATION_UPDATE_H
#define APPLICATION_UPDATE_H

#include "ui_application_update.h"
#include "Dialog.h"

#include <QHttp>

class ApplicationUpdate : public Dialog, private Ui::ApplicationUpdateDialog
{
    Q_OBJECT
public:
    ApplicationUpdate(QWidget *);
    ~ApplicationUpdate();
    void checkForUpdates(bool);

private:
    QHttp * httpConnection;
    bool silentCheck;
    QString latestVersion;

private slots:
    void processHttpResult(bool);
    void openWebsite();
    void skipThisVersion();
};

#endif
