/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef CHECKOUT_REVISION_H
#define CHECKOUT_REVISION_H

#include "Dialog.h"
#include "ui_checkout_revision.h"
#include "Select.h"
#include "Branches.h"
#include "Tags.h"

#include <QCompleter>

class CheckoutRevision : public Dialog, private Ui::CheckoutRevision
{
    Q_OBJECT

public:
    CheckoutRevision(QWidget *, const MonotoneHandlePtr &);
    ~CheckoutRevision();
    inline QString getSelectedRevision() const { return selectedRevisionId; }
    inline QDir getSelectedCheckoutDirectory() const {
        return selectedCheckoutDirectory;
    }

public slots:
    void setSelectedRevision(const QString &);

signals:
    void selectRevisionFromSelector(const QString &);
    void revisionCheckedOut(const MonotoneHandlePtr &);

private:
    Branches   * branchesModel;
    Tags       * tagsModel;
    QCompleter * selectorCompleter;
    QString      selectedRevisionId;
    QDir         selectedCheckoutDirectory;
    MonotoneHandlePtr monotoneHandle;

private slots:
    void slotSelectRevision();
    void accept();
    void selectBranchOption();
    void selectTagOption();
    void selectSelectorOption();
    void openDirBrowser();
};

#endif
