/***************************************************************************
 *   Copyright (C) 2006 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef COMMIT_REVISION_H
#define COMMIT_REVISION_H

#include "Dialog.h"
#include "ui_commit_revision.h"
#include "GetRevision.h"

class CommitRevision : public Dialog, private Ui::CommitRevision
{
    Q_OBJECT

public:
    CommitRevision(QWidget *, const MonotoneHandlePtr &);
    ~CommitRevision();

public slots:
    void readWorkspaceRevision(const QStringList &);

signals:
    void revisionCommitted(const QString &);
    void diffFile(const QString &);

private:
    GetRevision * revModel;
    MonotoneHandlePtr monotoneHandle;

private slots:
    void setChangelogEntryFromList(int);
    void revisionRead();
    void readFailed(const QString &);
    void accept();
    void changeViewDoubleClicked(const QModelIndex &);
};

#endif
