/***************************************************************************
 *   Copyright (C) 2010 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef CONNECTSERVERDIALOG_H
#define CONNECTSERVERDIALOG_H

#include "ui_connect_server.h"
#include "vocab.h"
#include "Dialog.h"

#include <QTimer>

class ConnectServerDialog : public Dialog, private Ui::ConnectServerDialog
{
    Q_OBJECT
public:
    ConnectServerDialog(QWidget *);

signals:
    void sourceSelected(const MonotoneHandlePtr &);

private slots:
    void serverConnectionChanged();
    void accept();

private:
    QTimer * timer;
    MonotoneHandlePtr lastValidatedHandle;
};

#endif

