/***************************************************************************
 *   Copyright (C) 2010 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef CREATECERT_H
#define CREATECERT_H

#include "ui_create_cert.h"
#include "Dialog.h"
#include "vocab.h"

#include <QMap>

class CreateCert : public Dialog, private Ui::CreateCertDialog
{
    Q_OBJECT

public:
    CreateCert(QWidget *, const MonotoneHandlePtr &);
    ~CreateCert();

    void init(const QString &, const QString & certName = QString());

signals:
    void selectRevision();
    void certCreated(const QString &, const QString &,
                     const QString &, const QString &);

public slots:
    void selectCertName(const QString &);
    void setSelectedRevision(const QString &);

private:
    QMap<QString, QString> nameTypeMap;
    QMap<QString, QWidget *> typeWidgetMap;

    MonotoneHandlePtr database;

private slots:
    void nameIndexChanged(int index);
    void accept();
};

#endif

