/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#include "Dialog.h"
#include "Settings.h"
#include "MainWindow.h"
#include "vocab.h"

#include <QMenuBar>

Dialog::Dialog(QWidget * parent) : QDialog(parent) {}

Dialog::Dialog(QWidget * parent, const QString & objName)
: QDialog(parent)
{
    setObjectName(objName);
}

Dialog::~Dialog()
{
    saveState();
}

void Dialog::init()
{
    restoreState();
}

void Dialog::restoreState(void)
{
    restoreGeometry(Settings::getWindowGeometry(objectName()));
}

void Dialog::saveState(void)
{
    Settings::setWindowGeometry(objectName(), saveGeometry());
}

void Dialog::setStayOnTop()
{
    if (isVisible()) return;
    setWindowFlags(windowFlags() | Qt::WindowStaysOnTopHint);
}

void Dialog::hideEvent(QHideEvent * event)
{
    emit dialogHidden();
    event->accept();
}

