/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef DIALOG_H
#define DIALOG_H

#include <QDialog>
#include <QHideEvent>

class Dialog : public QDialog
{
    Q_OBJECT
public:
    Dialog(QWidget *);
    Dialog(QWidget *, const QString &);
    ~Dialog();
    void init();
    void setStayOnTop();
    int execDocumentModal();

signals:
    void dialogHidden();

protected:
    virtual void hideEvent(QHideEvent *);

private:
    void restoreState(void);
    void saveState(void);
};

#endif

