/***************************************************************************
 *   Copyright (C) 2006 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef FILE_DIFF_H
#define FILE_DIFF_H

#include "Dialog.h"
#include "ui_file_diff.h"
#include "ContentDiff.h"
#include "GetFile.h"
#include "GetFileProxyModel.h"

class FileDiff : public Dialog, private Ui::FileDiffDialog
{
    Q_OBJECT
public:
    FileDiff(QWidget *);
    ~FileDiff();

    void init(const MonotoneHandlePtr &, const QString &,
              const QString &, const QString &);

private slots:
    void diffRead();
    void fileRead();
    void applyDiff();
    void versionToggled();
    void scrollToGroup(bool);
    void getPrevGroup();
    void getNextGroup();
    void changeCurrentIndex(int);
    void switchOutputEncoding(const QString &);

private:
    ContentDiff * diffModel;
    GetFile * fileModel;
    GetFileProxyModel * fileProxyModel;
    QModelIndex currentIndex;
    QString fileName;
    MonotoneHandlePtr monotoneHandle;
};

#endif
