/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef FILE_HISTORY_H
#define FILE_HISTORY_H

#include "Dialog.h"
#include "ui_file_history.h"
#include "Certs.h"
#include "GetContentChanged.h"

class FileHistory : public Dialog, private Ui::FileHistoryDialog
{
    Q_OBJECT
public:
    FileHistory(QWidget *, const MonotoneHandlePtr &);
    ~FileHistory();

    void readHistory(const QString &, const QString &);

signals:
    void fileDiff(const QString & fileName, const QString & firstRevision,
                  const QString & secondRevision);
private:
    GetContentChanged * changeModel;
    Certs             * certsModel;

    int curRow;
    QString firstRevision;
    QString secondRevision;
    QString fileName;

private slots:
    void readCerts(const QModelIndex &);
    void setFirstRevision();
    void setSecondRevision();
    void revisionFileListClicked(const QModelIndex &);
    void showDiffDialog();
};

#endif
