/***************************************************************************
 *   Copyright (C) 2009 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef NETSYNC_H
#define NETSYNC_H

#include "vocab.h"
#include "Dialog.h"
#include "AutomateCommand.h"
#include "ui_netsync.h"

class Netsync : public Dialog, public AutomateCommand, private Ui::NetsyncDialog
{
    Q_OBJECT
public:
    enum Action { Push, Pull, Sync };

    Netsync(QWidget *, const MonotoneHandlePtr &);
    ~Netsync();
    void init();

public slots:
    void start(Action,
               const QString &,
               const QString &,
               const QString &,
               const QString &);
    void stop();

protected:
    void processTaskResult(const MonotoneTaskPtr &);
    void processTaskAbortion(const MonotoneTaskPtr &);
    void tickerUpdate(const TickerMap &);

protected slots:
    void startStopClicked();

private:
    MonotoneHandlePtr monotoneHandle;
    bool running;
};

#endif
