/***************************************************************************
 *   Copyright (C) 2006 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef REVISION_DIFF_H
#define REVISION_DIFF_H

#include "Dialog.h"
#include "ui_revision_diff.h"
#include "ContentDiff.h"

class RevisionDiff : public Dialog, private Ui::RevisionDiffDialog
{
    Q_OBJECT
public:
    RevisionDiff(QWidget *);
    ~RevisionDiff();

    void init(const MonotoneHandlePtr &, const QString &,
              const QString &, const QString &);

signals:
    void fileDiff(const QString &, const QString &, const QString &);

private:
    ContentDiff * diffModel;
    QString baseRevision;
    QString targetRevision;
    QString filePath;

private slots:
    void triggerFileDiff(const QModelIndex &);
    void diffRead();
};

#endif
