/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef REVISION_MANIFEST_H
#define REVISION_MANIFEST_H

#include "Dialog.h"
#include "ui_manifest.h"
#include "Manifest.h"
#include "vocab.h"

#include <QPair>

class RevisionManifest : public Dialog, private Ui::ManifestDialog
{
    Q_OBJECT
public:
    RevisionManifest(QWidget *, const MonotoneHandlePtr &);
    ~RevisionManifest();

    void readManifest(const QString &);

signals:
    void fileHistory(const QString &, const QString &);
    void annotateFile(const QString &, const QString &);

private:
    FileEntryList extractSelectedEntries(const QModelIndexList &);
    FileEntryList addEntriesRecursive(ManifestEntry *);

    Manifest * manifestModel;
    QString revision;
    MonotoneHandlePtr monotoneHandle;

private slots:
    void saveSelectedFiles();
    void saveAllFiles();
    void openFile(const QModelIndex &);
    void contextMenuRequested(const QModelIndexList &, const QPoint &);
};

#endif
