/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef UNACCOUNTED_RENAMES_H
#define UNACCOUNTED_RENAMES_H

#include "Dialog.h"
#include "vocab.h"
#include "Inventory.h"
#include "ui_unaccounted_renames.h"

class UnaccountedRenames : public Dialog, private Ui::UnaccountedRenamesDialog
{
    Q_OBJECT
public:
    UnaccountedRenames(QWidget *, const MonotoneHandlePtr &);
    ~UnaccountedRenames();

    void checkForUnaccountedRenames();

signals:
    void renamePath(const QString &, const QString &);

private slots:
    void itemClicked(QTreeWidgetItem *, int);
    void findUnaccountedRenames();
    void doPerformRenames();

private:
    MonotoneHandlePtr monotoneHandle;
    Inventory * inventory;
};

#endif
