/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef WORKSPACE_DIALOG_MANAGER_H
#define WORKSPACE_DIALOG_MANAGER_H

#include "DatabaseDialogManager.h"
#include "CommitRevision.h"
#include "UnaccountedRenames.h"
#include "UpdateWorkspace.h"

#include <QMap>
#include <QStack>

class WorkspaceDialogManager : public DatabaseDialogManager
{
    Q_OBJECT
public:
    WorkspaceDialogManager(QWidget *);
    ~WorkspaceDialogManager();

    void closeAllDialogs();

    //! delegated signals
signals:
    void revisionCommitted(const QString &);
    void beforeWorkspaceUpdate();
    void workspaceUpdated(const QString &);
    void renamePath(const QString &, const QString &);

public slots:
    void showCommitRevision();
    void showCommitRevision(const QStringList & paths);
    void checkForUnaccountedRenames();
    void showUpdateWorkspace();
    void showFileDiff(const QString & file);
    void showFileHistory(const QString & file);
    void showAnnotation(const QString & file);

protected:
    CommitRevision      * commitRevision;
    UnaccountedRenames  * unaccountedRenames;
    UpdateWorkspace     * updateWorkspace;
};

#endif
