/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef DATABASEWINDOW_H
#define DATABASEWINDOW_H

#include "vocab.h"
#include "MainWindow.h"
#include "DatabaseVariables.h"

#include <QLabel>

class DatabaseWindow : public MainWindow
{
    Q_OBJECT
public:
    DatabaseWindow();
    virtual ~DatabaseWindow();

    virtual void init();
    virtual void setup();
    virtual void load(const MonotoneHandlePtr &);

protected:
    MonotoneHandlePtr monotoneHandle;

    QLabel              * loadedDbLabel;
    QPushButton         * keyManagement;
    QPushButton         * revisionBrowser;
    QPushButton         * checkoutRevision;
    DatabaseVariables   * databaseVariables;

protected slots:
    void checkForEmptyDatabase();
};

#endif
