/***************************************************************************
 *   Copyright (C) 2008 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef DATABASE_VARIABLES_H
#define DATABASE_VARIABLES_H

#include <QDockWidget>

#include "ui_db_variables.h"
#include "GetDatabaseVariables.h"

class DatabaseVariables : public QDockWidget, private Ui::DatabaseVariables
{
    Q_OBJECT
public:
    DatabaseVariables(QWidget *);
    ~DatabaseVariables();

public slots:
    void setMonotoneHandle(const MonotoneHandlePtr &);

private slots:
    void variablesRead();
    void openVariableEditor(const QString & domain = QString(),
                            const QString & key = QString(),
                            const QString & value= QString());
    void openVariableEditor(const QModelIndex &);
    void enableDisableDropButton(const QModelIndex &);
    void removeCurrentVariable();

private:
    GetDatabaseVariables * databaseVariables;
};

#endif
