/***************************************************************************
 *   Copyright (C) 2006 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef ATTRIBUTES_VIEW_H
#define ATTRIBUTES_VIEW_H

#include "TreeView.h"
#include <QMenu>

class AttributesView : public TreeView
{
    Q_OBJECT

public:
    AttributesView(QWidget *, const QString &);
    ~AttributesView();

private slots:
    void sectionClicked(int);
    void menuRequested(const QModelIndexList &, const QPoint &);

    void addAttribute();
    void editAttribute();
    void aboutToEditAttribute(const QModelIndex &);
    void dropAttribute();
    void dropAllAttributes();

private:
    QModelIndex selectedIndex;
    QString path;
};

#endif
