/***************************************************************************
 *   Copyright (C) 2010 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef BRANCH_VIEW_H
#define BRANCH_VIEW_H

#include "TreeView.h"
#include <QMenu>

class BranchView : public TreeView
{
    Q_OBJECT
public:
    BranchView(QWidget *);
    ~BranchView();

signals:
    void suspendBranch(const QString &);
    void displayBranchesAsTree(bool);
    void showSuspendedBranches(bool);
    void reloadBranchList();

private slots:
    void slotContextMenuRequested(const QModelIndexList &, const QPoint &);

private:
    QAction * actSuspendBranch;
    QAction * actDisplayAsTree;
    QAction * actShowSuspended;
    QAction * actReloadList;
};

#endif

