/***************************************************************************
 *   Copyright (C) 2010 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef CERT_LIST_BROWSER_H
#define CERT_LIST_BROWSER_H

#include "vocab.h"
#include "CertList.h"

#include <QTextBrowser>
#include <QMap>

class CertListBrowser : public QTextBrowser
{
    Q_OBJECT
public:
    CertListBrowser(QWidget *);
    ~CertListBrowser();
    void setKeyMap(const QMap<QString, QString> &);

public slots:
    void setCertList(const CertList &);

private:
    QMap<QString, QString> keyMap;
    QMap<QString, QString> nameI18NMap;

    enum format_type { none, table, definition };
    QList<QPair<QString, format_type> > certFormat;
    int certsPerTableRow;
};

#endif
