/***************************************************************************
 *   Copyright (C) 2008 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef CHANGE_LOG_EDIT_H
#define CHANGE_LOG_EDIT_H

#include <QTextEdit>
#include <QKeyEvent>
#include <QCompleter>

class ChangeLogEdit : public QTextEdit
{
    Q_OBJECT
public:
    ChangeLogEdit(QWidget *);
    ~ChangeLogEdit();

public slots:
    void setCompleterStrings(const QStringList &);

protected:
    void keyPressEvent(QKeyEvent *);

private slots:
    void insertCompletion(const QString &);

private:
    QString textUnderCursor() const;

    QCompleter * completer;
    bool completionEnabled;
};

#endif
