/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#include "DatabaseMenuBar.h"

DatabaseMenuBar::DatabaseMenuBar(QWidget * parent) : MenuBar(parent)
{
    //
    // The Database menu
    //
    actionNetsync = new QAction(tr("Network synchronisation"), this);
    actionNetsync->setShortcut(tr("F5"));
    actionChangeset_browser = new QAction(tr("Changeset browser"), this);
    actionChangeset_browser->setShortcut(tr("Ctrl+B"));
    actionKey_management = new QAction(tr("Key management"), this);
    actionKey_management->setShortcut(tr("Ctrl+K"));
    actionCheckout_revision = new QAction(tr("Checkout revision"), this);
    actionCheckout_revision->setShortcut(tr("Ctrl+Shift+U"));
    actionNew_project_setup = new QAction(tr("Create a new project"), this);

    menuDatabase = new QMenu(tr("Database"), this);

    menuDatabase->addAction(actionNetsync);
    menuDatabase->addSeparator();
    menuDatabase->addAction(actionChangeset_browser);
    menuDatabase->addAction(actionKey_management);
    menuDatabase->addSeparator();
    menuDatabase->addAction(actionCheckout_revision);
    menuDatabase->addAction(actionNew_project_setup);

    // insert the menu before the Window menu
    insertMenu(menuWindow->menuAction(), menuDatabase);

    connect(
        actionNetsync, SIGNAL(triggered()),
        this, SIGNAL(showNetsync())
    );

    connect(
        actionChangeset_browser, SIGNAL(triggered()),
        this, SIGNAL(showChangesetBrowser())
    );

    connect(
        actionKey_management, SIGNAL(triggered()),
        this, SIGNAL(showKeyManagement())
    );

    connect(
        actionCheckout_revision, SIGNAL(triggered()),
        this, SIGNAL(showCheckoutRevision())
    );

    connect(
        actionNew_project_setup, SIGNAL(triggered()),
        this, SIGNAL(showNewProjectSetup())
    );

    //
    // the dock widget menu
    //
    menuDockWidgets = new QMenu(tr("Panels"), this);
    menuWindow->addSeparator();
    menuWindow->addAction(menuDockWidgets->menuAction());
}

DatabaseMenuBar::~DatabaseMenuBar() {}

void DatabaseMenuBar::addDockWidgetAction(QAction * act)
{
    menuDockWidgets->addAction(act);
}

