/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef DATABASE_MENU_BAR_H
#define DATABASE_MENU_BAR_H

#include "MenuBar.h"

class DatabaseMenuBar : public MenuBar
{
    Q_OBJECT
public:
    DatabaseMenuBar(QWidget *);
    ~DatabaseMenuBar();

    void addDockWidgetAction(QAction * action);

signals:
    void showNetsync();
    void showCheckoutRevision();
    void showChangesetBrowser();
    void showKeyManagement();
    void showNewProjectSetup();

protected:
    QAction * actionNetsync;
    QAction * actionKey_management;
    QAction * actionChangeset_browser;
    QAction * actionCheckout_revision;
    QAction * actionNew_project_setup;

    QMenu * menuDatabase;
    QMenu * menuDockWidgets;
};

#endif

