/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#include "InventoryViewDelegate.h"

#include <QLineEdit>
#include <QAbstractItemModel>

InventoryViewDelegate::InventoryViewDelegate(QObject * parent)
    : QStyledItemDelegate(parent)
{}

QWidget * InventoryViewDelegate::createEditor(
    QWidget * parent,
    const QStyleOptionViewItem & option,
    const QModelIndex & index) const
{
    Q_UNUSED(option);
    Q_UNUSED(index);
    return new QLineEdit(parent);
}

void InventoryViewDelegate::setEditorData(QWidget * editor, const QModelIndex & index) const
{
    QLineEdit * lineEdit = qobject_cast<QLineEdit *>(editor);
    if (!lineEdit) return;
    lineEdit->setText(index.model()->data(index, Qt::EditRole).toString());
}

void InventoryViewDelegate::setModelData(
    QWidget * editor,
    QAbstractItemModel * model,
    const QModelIndex & index) const
{
    QLineEdit * lineEdit = qobject_cast<QLineEdit*>(editor);
    if (!lineEdit) return;
    model->setData(index, lineEdit->text(), Qt::EditRole);
}

