/***************************************************************************
 *   Copyright (C) 2010 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#include "ServerMenuBar.h"

ServerMenuBar::ServerMenuBar(QWidget * parent) : MenuBar(parent)
{
    //
    // The Server menu
    //
    actionNetsync = new QAction(tr("Network synchronisation"), this);
    actionNetsync->setShortcut(tr("F5"));
    actionChangeset_browser = new QAction(tr("Changeset browser"), this);
    actionChangeset_browser->setShortcut(tr("Ctrl+B"));

    menuServer = new QMenu(tr("Server"), this);

    menuServer->addAction(actionNetsync);
    menuServer->addAction(actionChangeset_browser);

    // insert the menu before the Window menu
    insertMenu(menuWindow->menuAction(), menuServer);

    connect(
        actionNetsync, SIGNAL(triggered()),
        this, SIGNAL(showNetsync())
    );

    connect(
        actionChangeset_browser, SIGNAL(triggered()),
        this, SIGNAL(showChangesetBrowser())
    );
}

ServerMenuBar::~ServerMenuBar() {}

