/***************************************************************************
 *   Copyright (C) 2010 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef SIZEABLE_LABEL_H
#define SIZEABLE_LABEL_H

#include <QLabel>

class SizeableLabel : public QLabel
{
    Q_OBJECT
    Q_PROPERTY(float relativeSize READ getRelativeSize WRITE setRelativeSize)
public:
    SizeableLabel(QWidget *);
    ~SizeableLabel();

    void setRelativeSize(float size);
    float getRelativeSize() const;

protected:
    float relativeSize;
};

#endif
